(* ------------------------------------------------------ *)
(*                     TESTSSAV.PAS                       *)
(*            Bildschirmschoner fr Turbo Vision          *)
(*         (c) 1993 Andres Cvitkovich & DMV-Verlag        *)
(* ------------------------------------------------------ *)
PROGRAM TestSsav;

USES Objects, Drivers, Views, Menus, App, AppS;

CONST
  cm1min = 1000;
  cm5sec = 1001;

TYPE
  tSApp = OBJECT (tApplicationS)
    PROCEDURE InitStatusLine;                   VIRTUAL;
    PROCEDURE HandleEvent(VAR Event : tEvent);  VIRTUAL;
  END;

  PROCEDURE tSApp.InitStatusLine;
  VAR
    R : tRect;
  BEGIN
    GetExtent(R);
    R.A.Y := R.B.Y - 1;
    StatusLine := New(pStatusLine, Init(R,
      NewStatusDef(0, $FFFF,
        NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
        NewStatusKey('~F4~ 1 Minute Time-Out', kbF4, cm1min,
        NewStatusKey('~F5~ 5 Sekunden Time-Out',kbF5,cm5sec,
      NIL))),
    NIL)));
  END;

  PROCEDURE tSApp.HandleEvent(VAR Event : tEvent);
  BEGIN
    tApplicationS.HandleEvent(Event);
    CASE Event.What OF
      evCommand : BEGIN
        CASE Event.Command OF
          cm1min: SetTimeOut(60);
          cm5sec: SetTimeOut(5);
        ELSE
          Exit;
        END;
        ClearEvent(Event);
      END;
    END;
  END;

VAR
  SApp : tSApp;

BEGIN
  SApp.Init (60);
  SApp.Run;
  SApp.Done;
END.
(* ------------------------------------------------------ *)
(*                Ende von TESTSSAV.PAS                   *)

